#include <signal.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>

#include <libps2000/ps2000.h>

bool stop = false;

void capture_stop(int signal) {
  (void)signal;
  stop = true;
}

void get_overview_buffers(int16_t** overviewBuffers, int16_t overflow, uint32_t triggeredAt, int16_t triggered, int16_t auto_stop, uint32_t nValues) {
  (void)overflow;
  (void)triggeredAt;
  (void)triggered;
  (void)auto_stop;

  fwrite(overviewBuffers[0], sizeof(int16_t), nValues, stdout);
}

int main(int argc, char** argv) {
  (void)argc;
  (void)argv;

  signal(SIGINT, &capture_stop);

  int16_t unit = ps2000_open_unit();

  if (ps2000_set_channel(unit, PS2000_CHANNEL_A, true, false, PS2000_100MV) == 0) {
    fprintf(stderr, "set channel unsuccesful!\n");
    ps2000_close_unit(unit);
    return 1;
  }

  if (ps2000_set_trigger(unit, PS2000_NONE, 0, 0, 0, 0) == 0) {
    fprintf(stderr, "set trigger unsuccesful!\n");
    ps2000_close_unit(unit);
    return 1;
  }

  if (ps2000_run_streaming_ns(unit, 100, PS2000_US, 100000, false, 1, 100000) == 0) {
    fprintf(stderr, "run streaming unsuccesful!\n");
    ps2000_close_unit(unit);
    return 1;
  }

  while (!stop) {
    ps2000_get_streaming_last_values(unit, &get_overview_buffers);
  }

  ps2000_stop(unit);
  ps2000_close_unit(unit);

  return 0;
}